require 'spec_helper'

describe Quietus::ActiveServer do
  context "creating" do
    context "passed a truthy block" do
      it "updates instance health to 'Healthy'" do
        aws_instance = double('instance')
        aws_instance.should_receive(:set_health).with(
          'Healthy',
          {
            :should_respect_grace_period => true
          }
        ).and_raise RspecLoopStop

        begin
          Quietus::ActiveServer.new(aws_instance) { true }
        rescue RspecLoopStop
          # Done
        end
      end
    end

    context "passed a falsy block" do
      it "updates instance health to 'Unhealthy'" do
        aws_instance = double('instance')
        aws_instance.should_receive(:set_health).with(
          'Unhealthy',
          {
            :should_respect_grace_period => true
          }
        ).and_raise RspecLoopStop

        begin
          Quietus::ActiveServer.new(aws_instance) { false }
        rescue RspecLoopStop
          # Done
        end
      end
    end
  end
end

